<?php

class CustomerAddressTest extends CakeTestCase {

	public function setUp() {
		parent::setUp();
		$this->CustomerAddress = ClassRegistry::init('BuzzCustomers.CustomerAddress');
	}

	public function testPostcodeValidation() {
		// Test a valid UK postcode.
		$this->CustomerAddress->data['CustomerAddress']['country_id'] = 225;
		$result = $this->CustomerAddress->validatePostcode(['S3 7BH']);
		$this->assertTrue($result);

		// Test an empty UK postcode.
		$this->CustomerAddress->data['CustomerAddress']['country_id'] = 225;
		$result = $this->CustomerAddress->validatePostcode(['']);
		$this->assertFalse($result);

		// Test an invalid UK postcode
		$this->CustomerAddress->data['CustomerAddress']['country_id'] = 225;
		$result = $this->CustomerAddress->validatePostcode(['S37BH']);
		$this->assertFalse($result);

		// Test an empty Irish postcode.
		$this->CustomerAddress->data['CustomerAddress']['country_id'] = 103;
		$result = $this->CustomerAddress->validatePostcode(['']);
		$this->assertTrue($result);

		return;
	}

	public function testUsStateValidation() {
		// Test a US state has been supplied for an American address.
		$this->CustomerAddress->data['CustomerAddress']['country_id'] = 226;
		$result = $this->CustomerAddress->validateRequiredByCountry(['us_state_id' => 1], 226);
		$this->assertTrue($result);

		$this->CustomerAddress->data['CustomerAddress']['country_id'] = 226;
		$result = $this->CustomerAddress->validateRequiredByCountry(['us_state_id' => null], 226);
		$this->assertFalse($result);

		$this->CustomerAddress->data['CustomerAddress']['country_id'] = 225;
		$result = $this->CustomerAddress->validateRequiredByCountry(['us_state_id' => null], 226);
		$this->assertTrue($result);

		return;
	}

}
